// Copyright © 2015, 2016 T-semi
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef INCLUDED_FINDER_FINDER_ADV_H
#define INCLUDED_FINDER_FINDER_ADV_H

#include "finder.h"

namespace finder{

struct marker_adv: marker{
    int notdetect_count;
    int iderror_count;
};

class finder_adv: public finder_context{
private:
    static const int id_overwrite_threash;
    static const int marker_remove_threash;

public:

    int markers_required;
    int not_enough_count;
    int id_unknown_count;

    std::vector<marker_adv> last_decide;

    finder_adv(int w, int h, int num_markers);
    ~finder_adv();

    void find_all();
    void track_all();
};

}

#endif  //INCLUDED_FINDER_FINDER_ADV_H
